function res = integ(ex, step, N)
% calculates the integral from - infinity to infinity of f(x) = 1./(1 + x.^2)
I = 0;
err = 2.*ex;
x = 0;
mstep = step;
k = 0;
while (x <= N)
    
    %calculate integral using midpoint rule
    xcalc = x + (labindex - .5).*step;
    y = f(xcalc);
    I = I + 2.*step.*y;
    if (labindex == 1)
        mstep = min([mstep step]);
    elseif (labindex == 2)
        mstep = max([mstep step]);
    end

    x = x + numlabs.*step;
    %stepsize adaption
    if (mod(k,100) == 0)
        %z = gather(darray(y,2));
        %diff = abs(z(1) - z(2));
        diff = abs(f(x + (.5 - numlabs).*step) - f(x + (1.5 - numlabs).*step));
        step = min([3.*step, (.8.*ex./(N.*(diff + 10.*eps))).^(1./3)]);
    end
    k = k+1;        
end

%output
res = [I, mstep, k];

function func = f(x)
func = 1./(1+x.^2);